문제
네 개의 명령어 D, S, L, R 을 이용하는 간단한 계산기가 있다. 이 계산기에는 레지스터가 하나 있는데, 이 레지스터에는 0 이상 10,000 미만의 십진수를 저장할 수 있다. 각 명령어는 이 레지스터에 저장된 n을 다음과 같이 변환한다. n의 네 자릿수를 d1, d2, d3, d4라고 하자(즉 n = ((d1 × 10 + d2) × 10 + d3) × 10 + d4라고 하자)
- D: D 는 n을 두 배로 바꾼다. 결과 값이 9999 보다 큰 경우에는 10000 으로 나눈 나머지를 취한다. 그 결과 값(2n mod 10000)을 레지스터에 저장한다.
- S: S 는 n에서 1 을 뺀 결과 n-1을 레지스터에 저장한다. n이 0 이라면 9999 가 대신 레지스터에 저장된다.
- L: L 은 n의 각 자릿수를 왼편으로 회전시켜 그 결과를 레지스터에 저장한다. 이 연산이 끝나면 레지스터에 저장된 네 자릿수는 왼편부터 d2, d3, d4, d1이 된다.
- R: R 은 n의 각 자릿수를 오른편으로 회전시켜 그 결과를 레지스터에 저장한다. 이 연산이 끝나면 레지스터에 저장된 네 자릿수는 왼편부터 d4, d1, d2, d3이 된다.
위에서 언급한 것처럼, L 과 R 명령어는 십진 자릿수를 가정하고 연산을 수행한다. 예를 들어서 n = 1234 라면 여기에 L 을 적용하면 2341 이 되고 R 을 적용하면 4123 이 된다.
여러분이 작성할 프로그램은 주어진 서로 다른 두 정수 A와 B(A ≠ B)에 대하여 A를 B로 바꾸는 최소한의 명령어를 생성하는 프로그램이다. 예를 들어서 A = 1234, B = 3412 라면 다음과 같이 두 개의 명령어를 적용하면 A를 B로 변환할 수 있다.
1234 →L 2341 →L 3412
1234 →R 4123 →R 3412
따라서 여러분의 프로그램은 이 경우에 LL 이나 RR 을 출력해야 한다.
n의 자릿수로 0 이 포함된 경우에 주의해야 한다. 예를 들어서 1000 에 L 을 적용하면 0001 이 되므로 결과는 1 이 된다. 그러나 R 을 적용하면 0100 이 되므로 결과는 100 이 된다.
입력
프로그램 입력은 T 개의 테스트 케이스로 구성된다. 테스트 케이스 개수 T 는 입력의 첫 줄에 주어진다. 각 테스트 케이스로는 두 개의 정수 A와 B(A ≠ B)가 공백으로 분리되어 차례로 주어지는데 A는 레지스터의 초기 값을 나타내고 B는 최종 값을 나타낸다. A 와 B는 모두 0 이상 10,000 미만이다.
출력
A에서 B로 변환하기 위해 필요한 최소한의 명령어 나열을 출력한다. 가능한 명령어 나열이 여러가지면, 아무거나 출력한다.
예제 입력 1
3
1234 3412
1000 1
1 16
예제 출력 1
LL
L
DDDD
풀이 1. (틀린코드 - 시간초과)
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayDeque;
import java.util.Queue;
import java.util.StringTokenizer;
class Pair {
String instruction;
String number;
Pair(String intstruction, String number) {
this.instruction = intstruction;
this.number = number;
}
}
public class Main {
static BufferedReader br = null;
static StringTokenizer st = null;
static boolean[] check = null;
static String ans;
public static String makeLengthFour(String str) {
int len = str.length();
String result = str;
for(int i = 0; i < len; i++) {
result = "0" + result;
}
return result;
}
public static String d(String strNum) {
int num = Integer.parseInt(strNum);
num = 2 * num % 10000;
String result = makeLengthFour(String.valueOf(num));
return result;
}
public static String s(String strNum) {
int num = Integer.parseInt(strNum);
if(num == 0) num = 9999;
else num -= 1;
String result = makeLengthFour(String.valueOf(num));
return result;
}
public static String l(String strNum) {
String temp = makeLengthFour(strNum);
String result = String.valueOf(temp.charAt(1));
result += String.valueOf(temp.charAt(2));
result += String.valueOf(temp.charAt(3));
result += String.valueOf(temp.charAt(0));
return result;
}
public static String r(String strNum) {
String temp = makeLengthFour(strNum);
String result = String.valueOf(temp.charAt(3));
result += String.valueOf(temp.charAt(0));
result += String.valueOf(temp.charAt(1));
result += String.valueOf(temp.charAt(2));
return result;
}
public static void bfs(int start, int destination) {
String strStart = String.valueOf(start);
Queue<Pair> que = new ArrayDeque<>();
que.add(new Pair("", makeLengthFour(strStart)));
check[start] = true;
while(!que.isEmpty()) {
Pair p = que.poll();
String inst = p.instruction;
String now = p.number;
String dStr = d(now), sStr = s(now), lStr = l(now), rStr = r(now);
int dNum = Integer.parseInt(dStr), sNum = Integer.parseInt(sStr), lNum = Integer.parseInt(lStr), rNum = Integer.parseInt(rStr);
if(dNum == destination) {ans = inst + "D"; return;}
if(sNum == destination) {ans = inst + "S"; return;}
if(lNum == destination) {ans = inst + "L"; return;}
if(rNum == destination) {ans = inst + "R"; return;}
if(!check[dNum]) {que.add(new Pair(inst + "D", dStr)); check[dNum] = true;}
if(!check[sNum]) {que.add(new Pair(inst + "S", sStr)); check[sNum] = true;}
if(!check[lNum]) {que.add(new Pair(inst + "L", lStr)); check[lNum] = true;}
if(!check[rNum]) {que.add(new Pair(inst + "R", rStr)); check[rNum] = true;}
}
}
public static void main(String[] args) throws IOException {
br = new BufferedReader(new InputStreamReader(System.in));
int T = Integer.parseInt(br.readLine());
while(T-- > 0) {
st = new StringTokenizer(br.readLine());
int from = Integer.parseInt(st.nextToken());
int to = Integer.parseInt(st.nextToken());
check = new boolean[10000];
bfs(from, to);
System.out.println(ans);
}
}
}
String 연산을 쓸데없이 많이 사용해서 시간초과가 난 거 같다.
숫자의 길이에 대한 주의사항 때문에 일부러 makeLengthFour() 같은 것도 만들고 이것저것 신경을 썼는데.. 오히려 그게 시간초과로 발목을 잡았다.
풀이 2. (정답코드)
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayDeque;
import java.util.Arrays;
import java.util.Queue;
import java.util.StringTokenizer;
public class Main {
static BufferedReader br = null;
static StringTokenizer st = null;
static boolean[] check = null;
static String[] instructions = null;
static String ans;
public static void bfs(int start, int destination) {
Queue<Integer> que = new ArrayDeque<>();
que.add(start);
check[start] = true;
while(!que.isEmpty()) {
int now = que.poll();
int D = 2 * now % 10000;
int S = (now-1 == -1) ? 9999 : now-1;
int L = (now % 1000) * 10 + (now / 1000);
int R = (now / 10) + (now % 10) * 1000;
if(D == destination) { ans = instructions[now] + "D"; return; }
if(S == destination) { ans = instructions[now] + "S"; return; }
if(L == destination) { ans = instructions[now] + "L"; return; }
if(R == destination) { ans = instructions[now] + "R"; return; }
if(!check[D]) { que.add(D); check[D] = true; instructions[D] = instructions[now] + "D"; }
if(!check[S]) { que.add(S); check[S] = true; instructions[S] = instructions[now] + "S"; }
if(!check[L]) { que.add(L); check[L] = true; instructions[L] = instructions[now] + "L"; }
if(!check[R]) { que.add(R); check[R] = true; instructions[R] = instructions[now] + "R"; }
}
}
public static void main(String[] args) throws IOException {
br = new BufferedReader(new InputStreamReader(System.in));
int T = Integer.parseInt(br.readLine());
while(T-- > 0) {
st = new StringTokenizer(br.readLine());
int from = Integer.parseInt(st.nextToken());
int to = Integer.parseInt(st.nextToken());
check = new boolean[10000];
instructions = new String[10000];
Arrays.fill(instructions, "");
bfs(from, to);
System.out.println(ans);
}
}
}
애초부터 String을 그렇게 남발할 필요도 없었고 D, S, L, R 각 명령을 함수로 만들 필요도 없었다.
'알고리즘 문제 > 백준 온라인 저지' 카테고리의 다른 글
[BOJ] 1525 - 퍼즐 JAVA (0) | 2021.02.12 |
---|---|
[BOJ] 2251 - 물통 JAVA (0) | 2021.02.12 |
[BOJ] 1963 - 소수 경로 JAVA (0) | 2021.02.11 |
[BOJ] 1697 - 숨바꼭질 JAVA (0) | 2021.02.11 |
[BOJ] 10971 - 외판원 순회 2 JAVA (0) | 2021.02.11 |